// --------------------------------------------------------------------
// Scripted transitions: Walking
//
// Scripted transition that makes object look like it's walking in/out
// --------------------------------------------------------------------
// Events: Walking.OnShow, Walking.OnHide
// --------------------------------------------------------------------

// Constants
const float WALKING_HEIGHT = 10.0f;


// Walk in from the left
event Walking.OnShow
{
	// Store original position
	if (value == 0.0f)
		self.$origin = self.position;
	
	// Set position
	self.position.x = self.$origin.AsVector2().x - (invert(value) * self.size.x);
	self.position.y = self.$origin.AsVector2().y + abs( sin(value * PI * 4.0f)) * WALKING_HEIGHT;
	
	// Fade in
	self.SetOpacity(value);

	// Restore original position when done
	if (value == 1.0f)
	{
		self.position = self.$origPos.AsVector2();
		_VAR_ERASE(self, "origPos");
	}
}

// Walk out to the right
event Walking.OnHide
{
	// Store original position
	if (value == 0.0f)
		self.$origPos = self.position;

	// Set position
	self.position.x = self.$origPos.AsVector2().x + ( value * self.size.x);
	self.position.y = self.$origPos.AsVector2().y + abs( sin( invert(value) * PI * 4.0f)) * WALKING_HEIGHT;
	
	// Fade out
	self.SetOpacity ( invert(value) );

	// Restore original position when done
	if (value == 1.0f)
	{
		self.position = self.$origPos.AsVector2();
		_VAR_ERASE(self,"origPos");
	}
}